# Create a new segment POST https://app.unleash-instance.example.com/api/admin/segments Content-Type: application/json Creates a new segment using the payload provided Reference: https://docs.getunleash.io/api/create-segment ## OpenAPI Specification ```yaml openapi: 3.1.1 info: title: Create a new segment version: endpoint_segments.createSegment paths: /api/admin/segments: post: operationId: create-segment summary: Create a new segment description: Creates a new segment using the payload provided tags: - - subpackage_segments parameters: - name: Authorization in: header description: Header authentication of the form `undefined ` required: true schema: type: string responses: '201': description: The resource was successfully created. content: application/json: schema: $ref: '#/components/schemas/adminSegmentSchema' '400': description: The request data does not match what we expect. content: {} '401': description: >- Authorization information is missing or invalid. Provide a valid API token as the `authorization` header, e.g. `authorization:*.*.my-admin-token`. content: {} '403': description: >- The provided user credentials are valid, but the user does not have the necessary permissions to perform this operation content: {} '409': description: >- The provided resource can not be created or updated because it would conflict with the current state of the resource or with an already existing resource, respectively. content: {} '415': description: >- The operation does not support request payloads of the provided type. Please ensure that you're using one of the listed payload types and that you have specified the right content type in the "content-type" header. content: {} requestBody: description: upsertSegmentSchema content: application/json: schema: $ref: '#/components/schemas/upsertSegmentSchema' components: schemas: ConstraintSchemaOperator: type: string enum: - value: NOT_IN - value: IN - value: STR_ENDS_WITH - value: STR_STARTS_WITH - value: STR_CONTAINS - value: NUM_EQ - value: NUM_GT - value: NUM_GTE - value: NUM_LT - value: NUM_LTE - value: DATE_AFTER - value: DATE_BEFORE - value: SEMVER_EQ - value: SEMVER_GT - value: SEMVER_LT constraintSchema: type: object properties: contextName: type: string description: The name of the context field that this constraint should apply to. operator: $ref: '#/components/schemas/ConstraintSchemaOperator' description: >- The operator to use when evaluating this constraint. For more information about the various operators, refer to [the strategy constraint operator documentation](https://docs.getunleash.io/concepts/activation-strategies#constraint-operators). caseInsensitive: type: boolean default: false description: >- Whether the operator should be case sensitive or not. Defaults to `false` (being case sensitive). inverted: type: boolean default: false description: >- Whether the result should be negated or not. If `true`, will turn a `true` result into a `false` result and vice versa. values: type: array items: type: string description: >- The context values that should be used for constraint evaluation. Use this property instead of `value` for properties that accept multiple values. value: type: string description: >- The context value that should be used for constraint evaluation. Use this property instead of `values` for properties that only accept single values. required: - contextName - operator upsertSegmentSchema: type: object properties: name: type: string description: The name of the segment description: type: - string - 'null' description: A description of what the segment is for project: type: - string - 'null' description: The project the segment belongs to if any. constraints: type: array items: $ref: '#/components/schemas/constraintSchema' description: The list of constraints that make up this segment required: - name - constraints adminSegmentSchema: type: object properties: id: type: integer description: The ID of this segment name: type: string description: The name of this segment description: type: - string - 'null' description: The description for this segment constraints: type: array items: $ref: '#/components/schemas/constraintSchema' description: The list of constraints that are used in this segment usedInFeatures: type: - integer - 'null' description: >- The number of feature flags that use this segment. The number also includes the any flags with pending change requests that would add this segment. usedInProjects: type: - integer - 'null' description: >- The number of projects that use this segment. The number includes any projects with pending change requests that would add this segment. project: type: - string - 'null' description: >- The project the segment belongs to. Only present if the segment is a project-specific segment. createdBy: type: - string - 'null' description: The creator's email or username createdAt: type: string format: date-time description: When the segment was created required: - id - name - constraints - createdAt ``` ## SDK Code Examples ```python import requests url = "https://app.unleash-instance.example.com/api/admin/segments" payload = { "name": "beta-users", "constraints": [ { "contextName": "appName", "operator": "IN" } ] } headers = { "Authorization": "", "Content-Type": "application/json" } response = requests.post(url, json=payload, headers=headers) print(response.json()) ``` ```javascript const url = 'https://app.unleash-instance.example.com/api/admin/segments'; const options = { method: 'POST', headers: {Authorization: '', 'Content-Type': 'application/json'}, body: '{"name":"beta-users","constraints":[{"contextName":"appName","operator":"IN"}]}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://app.unleash-instance.example.com/api/admin/segments" payload := strings.NewReader("{\n \"name\": \"beta-users\",\n \"constraints\": [\n {\n \"contextName\": \"appName\",\n \"operator\": \"IN\"\n }\n ]\n}") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("Authorization", "") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://app.unleash-instance.example.com/api/admin/segments") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Authorization"] = '' request["Content-Type"] = 'application/json' request.body = "{\n \"name\": \"beta-users\",\n \"constraints\": [\n {\n \"contextName\": \"appName\",\n \"operator\": \"IN\"\n }\n ]\n}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://app.unleash-instance.example.com/api/admin/segments") .header("Authorization", "") .header("Content-Type", "application/json") .body("{\n \"name\": \"beta-users\",\n \"constraints\": [\n {\n \"contextName\": \"appName\",\n \"operator\": \"IN\"\n }\n ]\n}") .asString(); ``` ```php request('POST', 'https://app.unleash-instance.example.com/api/admin/segments', [ 'body' => '{ "name": "beta-users", "constraints": [ { "contextName": "appName", "operator": "IN" } ] }', 'headers' => [ 'Authorization' => '', 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://app.unleash-instance.example.com/api/admin/segments"); var request = new RestRequest(Method.POST); request.AddHeader("Authorization", ""); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"name\": \"beta-users\",\n \"constraints\": [\n {\n \"contextName\": \"appName\",\n \"operator\": \"IN\"\n }\n ]\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = [ "Authorization": "", "Content-Type": "application/json" ] let parameters = [ "name": "beta-users", "constraints": [ [ "contextName": "appName", "operator": "IN" ] ] ] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://app.unleash-instance.example.com/api/admin/segments")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```